<template>
    <div class="list-view">
        <div class="filters-container">
            <el-form :model="form" inline size="mini">
                <el-form-item label="标题" style="margin-right: 50px">
                    <el-input placeholder="输入标题" v-model="search" clearable></el-input>
                </el-form-item>
                <el-form-item label="办理情况">
                    <el-select v-model="situationIsReal" clearable placeholder="请选择">
                        <el-option :value="true" label="属实"></el-option>
                        <el-option :value="false" label="不属实"></el-option>
                    </el-select>
                </el-form-item>
                <br />
                <el-form-item>
                    <el-button @click="getData" type="primary" icon="el-icon-search">搜索 </el-button>
                    <el-button @click="addRow" type="primary" icon="el-icon-plus">添加 </el-button>
                    <!-- <el-button @click="download" type="primary" icon="el-icon-download" :loading="downloading"
                        >导出EXCEL
                    </el-button> -->
                </el-form-item>
            </el-form>
        </div>
        <el-table
            :data="tableData"
            row-key="id"
            ref="table"
            header-row-class-name="table-header-row"
            header-cell-class-name="table-header-cell"
            row-class-name="table-row"
            cell-class-name="table-cell"
            :height="tableHeight"
        >
            <el-table-column v-if="multipleMode" align="center" type="selection" width="50"> </el-table-column>
            <el-table-column prop="id" label="ID" width="60"> </el-table-column>
            <el-table-column prop="title" label="标题"> </el-table-column>
            <el-table-column prop="complainAt" label="来电时间"> </el-table-column>
            <el-table-column prop="name" label="联系人"> </el-table-column>
            <!-- <el-table-column prop="sex" label="性别"> </el-table-column> -->
            <el-table-column prop="phone" label="联系方式"> </el-table-column>
            <el-table-column prop="finish" label="状态">
                <template slot-scope="{ row }">
                    <span v-if="row.finish">办结</span>
                    <span v-else>未办结</span>
                </template>
            </el-table-column>
            <el-table-column prop="situationIsReal" label="办理情况">
                <template slot-scope="{ row }">
                    <span v-if="!row.situationIsReal">暂无</span>
                    <span v-else-if="row.situationIsReal == true">属实</span>
                    <span v-else>不属实</span>
                </template>
            </el-table-column>
            <el-table-column label="操作" align="left" fixed="right" min-width="150">
                <template slot-scope="{ row }">
                    <el-button @click="showRow(row)" size="mini" plain>查看</el-button>
                    <el-button @click="editRow(row)" type="primary" size="mini" plain v-if="!row.finish"
                        >处理</el-button
                    >
                    <!-- <el-button @click="deleteRow(row)" type="danger" size="mini" plain>删除</el-button> -->
                </template>
            </el-table-column>
        </el-table>
        <div class="pagination-wrapper">
            <!-- <div class="multiple-mode-wrapper">
                <el-button v-if="!multipleMode" @click="toggleMultipleMode(true)">批量编辑</el-button>
                <el-button-group v-else>
                    <el-button @click="operation1">批量操作1</el-button>
                    <el-button @click="operation2">批量操作2</el-button>
                    <el-button @click="toggleMultipleMode(false)">取消</el-button>
                </el-button-group>
            </div> -->
            <el-pagination
                background
                @size-change="onSizeChange"
                @current-change="onCurrentChange"
                :current-page="page"
                :page-sizes="[10, 20, 30, 40, 50]"
                :page-size="pageSize"
                layout="total, sizes, prev, pager, next, jumper"
                :total="totalElements"
            >
            </el-pagination>
        </div>
    </div>
</template>
<script>
import { mapState } from 'vuex';
import pageableTable from '@/mixins/pageableTable';

export default {
    name: 'ComplainList',
    mixins: [pageableTable],
    data() {
        return {
            multipleMode: false,
            search: '',
            url: '/complain/all',
            downloading: false,
            unitTypeOptions: [
                { label: '承办单位', value: 'ORGANIZATION' },
                { label: '考级机构', value: 'GRADING_ORGANIZATION' },
                { label: '考点', value: 'EXAMINATION' }
            ],
            situationIsReal: '',
            form: {}
        };
    },
    computed: {
        selection() {
            return this.$refs.table.selection.map(i => i.id);
        }
    },
    methods: {
        unitTypeFormatter(row, column, cellValue, index) {
            let selectedOption = this.unitTypeOptions.find(i => i.value === cellValue);
            if (selectedOption) {
                return selectedOption.label;
            }
            return '';
        },
        beforeGetData() {
            return {
                sort: 'createdAt,desc',
                search: this.search,
                query: {
                    situationIsReal: this.situationIsReal
                }
            };
        },
        toggleMultipleMode(multipleMode) {
            this.multipleMode = multipleMode;
            if (!multipleMode) {
                this.$refs.table.clearSelection();
            }
        },
        addRow() {
            this.$router.push({
                path: '/complainEdit',
                query: {
                    ...this.$route.query
                }
            });
        },
        editRow(row) {
            this.$router.push({
                path: '/complainEdit',
                query: {
                    id: row.id
                }
            });
        },
        showRow(row) {
            this.$router.push({
                path: '/complainShow',
                query: {
                    id: row.id
                }
            });
        },
        download() {
            this.downloading = true;
            this.$axios
                .get('/complain/excel', {
                    responseType: 'blob',
                    params: { size: 10000 }
                })
                .then(res => {
                    console.log(res);
                    this.downloading = false;
                    const downloadUrl = window.URL.createObjectURL(new Blob([res.data]));
                    const link = document.createElement('a');
                    link.href = downloadUrl;
                    link.setAttribute('download', res.headers['content-disposition'].split('filename=')[1]);
                    document.body.appendChild(link);
                    link.click();
                    link.remove();
                })
                .catch(e => {
                    console.log(e);
                    this.downloading = false;
                    this.$message.error(e.error);
                });
        },
        operation1() {
            this.$notify({
                title: '提示',
                message: this.selection
            });
        },
        operation2() {
            this.$message('操作2');
        },
        deleteRow(row) {
            this.$alert('删除将无法恢复，确认要删除么？', '警告', { type: 'error' })
                .then(() => {
                    return this.$http.post(`/complain/del/${row.id}`);
                })
                .then(() => {
                    this.$message.success('删除成功');
                    this.getData();
                })
                .catch(e => {
                    if (e !== 'cancel') {
                        this.$message.error(e.error);
                    }
                });
        }
    }
};
</script>
<style lang="less" scoped></style>
